# Class PluginActionSetBuilder

java.lang.Object
org.eclipse.ui.internal.registry.RegistryReader
org.eclipse.ui.internal.PluginActionBuilder
org.eclipse.ui.internal.PluginActionSetBuilder

public class PluginActionSetBuilder extends PluginActionBuilder
This builder reads the actions for an action set from the registry.

## Nested Class Summary

Nested Classes
Modifier and Type
Class
Description
`static class`
`PluginActionSetBuilder.Binding`
Used by the workbench window extension handler to unhook action sets from their associated window.

### Nested classes/interfaces inherited from class PluginActionBuilder

`PluginActionBuilder.BasicContribution`

## Field Summary

### Fields inherited from class PluginActionBuilder

`cache, currentContribution, targetContributionTag, targetID`

## Constructor Summary

Constructors
Constructor
Description
`PluginActionSetBuilder()`
Constructs a new builder.

## Method Summary

Modifier and Type
Method
Description
`void`
`buildMenuAndToolBarStructure(PluginActionSet set, IWorkbenchWindow window)`
Read the actions within a config element.
`protected ActionDescriptor`
`createActionDescriptor(IConfigurationElement element)`
This factory method returns a new ActionDescriptor for the configuration element.
`protected PluginActionBuilder.BasicContribution`
`createContribution()`
Factory method to create the helper contribution class that will hold onto the menus and actions contributed.
`static IContributionItem`
`findInsertionPoint(String startId, String sortId, IContributionManager mgr, boolean startVsEnd)`
Returns the insertion point for a new contribution item.
`protected void`
`processAdjunctContributions()`
`protected void`
`readActionExtensions(PluginActionSet set, IWorkbenchWindow window)`
Read the actions within a config element.
`protected void`
`removeActionExtensions(PluginActionSet set, IWorkbenchWindow window)`
Remove the given action set from the window.

### Methods inherited from class PluginActionBuilder

`contribute, getID, getTargetID, readContributions, readElement, setAllowIdeLogging`

### Methods inherited from class org.eclipse.ui.internal.registry.RegistryReader

`getClassValue, getDescription, logError, logMissingAttribute, logMissingElement, logUnknownElement, orderExtensions, readElementChildren, readElements, readExtension, readRegistry`

### Methods inherited from class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### PluginActionSetBuilder

public PluginActionSetBuilder()
Constructs a new builder.

## Method Details

### buildMenuAndToolBarStructure

public void buildMenuAndToolBarStructure(PluginActionSet set, IWorkbenchWindow window)
Read the actions within a config element. Called by customize perspective

Parameters:
  `set` - the action set
  `window` - the window to contribute to

### createActionDescriptor

protected ActionDescriptor createActionDescriptor(IConfigurationElement element)
Description copied from class: `PluginActionBuilder`
This factory method returns a new ActionDescriptor for the configuration element. It should be implemented by subclasses.

Specified by:
  `createActionDescriptor` in class `PluginActionBuilder`

### createContribution

protected PluginActionBuilder.BasicContribution createContribution()
Description copied from class: `PluginActionBuilder`
Factory method to create the helper contribution class that will hold onto the menus and actions contributed.

Overrides:
  `createContribution` in class `PluginActionBuilder`

### findInsertionPoint

public static IContributionItem findInsertionPoint(String startId, String sortId, IContributionManager mgr, boolean startVsEnd)
Returns the insertion point for a new contribution item. Clients should use this item as a reference point for insertAfter.

Parameters:
  `startId` - the reference id for insertion
  `sortId` - the sorting id for the insertion. If null then the item will be inserted at the end of all action sets.
  `mgr` - the target menu manager.
  `startVsEnd` - if `true` the items are added at the start of action with the same id; else they are added to the end
Returns:
  the insertion point, or null if not found.

### processAdjunctContributions

protected void processAdjunctContributions()

### readActionExtensions

protected void readActionExtensions(PluginActionSet set, IWorkbenchWindow window)
Read the actions within a config element.

### removeActionExtensions

protected void removeActionExtensions(PluginActionSet set, IWorkbenchWindow window)
Remove the given action set from the window.

Parameters:
  `set` - the set to remove
  `window` - the window to remove from